#include <fstream>
#include <vector>
using namespace std;

typedef vector<int> VI;

vector<VI> G;
vector<bool> s;
VI niv;
VI father;
int n;
int Q;   // nr interogari
ofstream fout("graf.out");


void Solve();
void DF(int v, int nv);
int LCA(int, int);

int main()
{
    Solve();
    fout.close();
    return 0;
}


void Solve()
{
    ifstream fin("graf.in");
    fin >> n;
    s.resize(n + 1);
    G.resize(n + 1);
    niv.resize(n + 1);
    father.resize(n + 1);
    int x, y;
    for ( int i = 1; i < n; ++i )
    {
        fin >> x >> y;
        G[x].push_back(y);
        G[y].push_back(x);
    }

    DF(1, 1);

    fin >> Q;
    for ( int i = 0; i < Q; ++i )
    {
        fin >> x >> y;
        fout << LCA(x, y) << '\n';
    }

    fin.close();

}

void DF(int v, int nv)
{
    s[v] = true;
    niv[v] = nv;
    for ( int i = 0; i < G[v].size(); ++i )
        if ( !s[G[v][i]] )
        {
            father[G[v][i]] = v;
            DF(G[v][i], nv + 1);
        }

}


int LCA(int x, int y)
{
    while ( x != y )
        if ( niv[x] > niv[y])
            x = father[x];
        else
            y = father[y];
    return x;
}
