// RMQ
// aplicat  pb 7   USACO 2004  Orange problems
// Complexitate RMQ ( O(N*log N), O(1) )       (preprocessing, query)

#include <stdio.h>
#include <math.h>
long int a[251][17];
long int l[251];
long int n, q, k, i, j, x, y;


long int Min(long int a, long int b);
/* rmq  ... a[i][j] reprezinta elementul minim din sir cu
   proprietatea ca  este  i <= indexul in sir <=i+2^j-1
*/
int main()
{
	freopen("cavecow2.in", "r", stdin);
	scanf("%ld %ld", &n, &q);
  	for (i = 1; i <= n; i++)     // sirul e bagat pe coloana 0
		scanf("%ld", &a[i][0]);  // a[i][0] = minimul sirului de elemente
                                 // in intervalul [i, i + 2^0 - 1] = i
  k = 0;
  while (1 << k <= n)  k++;
  k--;

  for ( j = 1; j <= k; j++ )       // cobor pe coloana
    for ( i = 1; i <= n; i++ )  // intervalul [i, 2^j -1] e impartit in 2;
    {
      a[i][j] = a[i][j-1];       // minim in interv [i, i + 2^(j-1) -1]
      if (i + (1 << (j-1)) <= n && a[i][j] > a[i+(1 << (j-1))][j-1] )  // a[i+(1<<(j-1))][j-1]]  e min in inter-
		  a[i][j] = a[i+(1 << (j-1))][j-1];                            // valul [i+2^(j-1), i + 2^j -1]
	}
/*
  l[1] = 0;
  for ( i = 2; i <= n; i++ )l[i] = 1 + l[i >> 1];    // calculeaza floor(log2(i))
*/
  freopen("caveco2.out", "w", stdout);
  for ( i = 1; i <= q; i++ ) // pt fiecare query
  {
    scanf("%ld %ld", &x, &y);
    if (x == y)
    {
      printf("%ld\n", a[x][0]);
      continue;
  	}

  //  k = l[y-x];  // e bun dar mai jos am folosit formula pt log2(a)
  	k = floor(log(y-x)/log(2)); // log2(a) = ln(a)/ln(2)
	printf("%ld\n", Min(a[x][k], a[y-(1 << k)+1][k]));
  }
  fclose(stdin);
  fclose(stdout);

  return 0;
}

long int Min(long int a, long int b)
{
  if ( a > b ) return b;
  return a;
}
