// OK - POZITIA MINIMULUI (RMQ)
#include <stdio.h>
#include <math.h>

long int a[251][17];
long int v[251];
long int l[251];
long int n, q, k, i, j, x, y;


long int Min(long int a, long int b);
/* rmq  ... a[i][j] reprezinta POZITIA elementului minim din sir cu
   proprietatea ca indexul in sir e >=i si <=i+2^j-1
*/
int main()
{
	freopen("cavecow2.in", "r", stdin);
	scanf("%ld %ld", &n, &q);
	for (i = 1; i <= n; i++)
	{
		scanf("%ld", &v[i]);  //
		a[i][0] = i;          // [i, i + 2^0 - 1]pozitiile elementelor sunt pe prima coloana
	}

/*
  k = 0;
  while (1 << k <= n)  k++;
  k--;
*/
	k = floor(log(n)/log(2)); // la fel ca mai sus k = log2(n)

  for ( j = 1; j <= k; j++ )
	for ( i = 1; i <= n; i++ )
	{
		a[i][j] = a[i][j-1];
		if (i + (1 << (j-1)) <= n && v[a[i][j]] > v[a[i+(1 << (j-1))][j-1]] )
			a[i][j] = a[i+(1 << (j-1))][j-1];
	}

  l[1] = 0;
  for ( i = 2; i <= n; i++ ) l[i] = 1 + l[i >> 1];    // calculeaza log2(i)

  freopen("caveco2.out", "w", stdout);
  for ( i = 1; i <= q; i++ ) // pt fiecare query
  {
	scanf("%ld %ld", &x, &y);
	if (x == y)
	{
	  printf("%ld\n", v[a[x][0]]);
	  continue;
	}

  //  k = l[y-x];
	k = floor(log(y-x)/log(2)); // log2(a) = ln(a)/ln(2)
	printf("%ld\n", Min(v[a[x][k]], v[a[y-(1 << k)+1][k]]));
  }
  fclose(stdin);
  fclose(stdout);

  return 0;
}

long int Min(long int a, long int b)
{
  if ( a > b ) return b;
  return a;
}
