{
PROG: cavecow2
LANG: PASCAL
}

{ Complexitate O(n log n) preprocesare si O(1) querie}

var a:array[1..25000,0..16] of longint;
    l:array[0..25000] of longint;
    n,q,k,i,j,x,y:longint;
    fi,fo:text;

function min(a,b:longint):longint;
begin
  if a>b then min:=b else min:=a;
end;

{ rmq  ... a[i][j] reprezint elementu minim din sir cu }
{proprietatea ca indexul in sir e >=i si <=i+2^j-1     }
begin
  assign(fi,'cavecow2.in');reset(fi);
  readln(fi,n,q);
  for i:=1 to n do readln(fi,a[i][0]);  { sirul e bagat pe coloana 0 }
  k:=0;
  while 1 shl k<=n do inc(k);
  dec(k);
  for j:=1 to k do
    for i:=1 to n do begin
      a[i][j]:=a[i][j-1];
      if (i+(1 shl (j-1))<=n) and (a[i][j]>a[i+(1 shl (j-1)),j-1]) then
          a[i][j]:=a[i+(1 shl (j-1)),j-1];
    end;
  l[1]:=0;
  for i:=2 to n do l[i]:=1+l[i shr 1];    { calculeaza log2(i) }
  assign(fo,'cavecow2.out');rewrite(fo);
  for i:=1 to q do begin   { pt fiecare query }
    readln(fi,x,y);
    if x=y then begin
      writeln(fo,a[x][0]);
      continue;
    end;
    k:=l[y-x];
    writeln(fo,min(a[x][k],a[y-(1 shl k)+1][k]));
  end;
  close(fi);
  close(fo);
end.
